from proxy4_base import *
from connection import *
from http_server import Server

class ServerHandleDirectly(Server):
    def __init__(self, client, response, headers, content):
        self.response = response
        self.headers = rfc822.Message(StringIO(headers))
        self.content = content
        # NOTE: we could insert the content-length here
        Server.__init__(self, client)
        
        self.connected = 1
        client.server_response(self, self.response, self.headers)
        client.server_content(self.content)
        client.server_close()
        self.connected = 0
        
